//------------------------------------------------------------------------
// File : asdxDemoCamera.h
// Desc : Asura Camera For Demo Application 
// Copyright(c) Project Asura. All right reserved.
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// History
//------------------------------------------------------------------------
// <--> 2011/08/22 [Pocol] VK쐬
// <End>

#ifndef __ASURA_DIRECTX_DEMO_CAMERA_H__
#define __ASURA_DIRECTX_DEMO_CAMERA_H__

//------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------
#include <d3dx10math.h>

namespace Asura {
namespace SampleProgram {

//////////////////////////////////////////////////////////////////////////
// DemoCamera class
//////////////////////////////////////////////////////////////////////////
class DemoCamera
{
private:
    //--------------------------------------------------------------------
    // private variables
    //--------------------------------------------------------------------
    /* NOTHING */

    //--------------------------------------------------------------------
    // private methods
    //--------------------------------------------------------------------
    /* NOTHING */

protected:
    //--------------------------------------------------------------------
    // protected variables
    //--------------------------------------------------------------------
    /* NOTHING */

    //--------------------------------------------------------------------
    // protected methods
    //--------------------------------------------------------------------
    DemoCamera() {}
    virtual ~DemoCamera() {}
    DemoCamera( const DemoCamera &camera ) {}
    DemoCamera& operator = ( const DemoCamera &camera ) { return (*this); }

public:
    //--------------------------------------------------------------------
    // public variables
    //--------------------------------------------------------------------
    /* NOTHING */

    //--------------------------------------------------------------------
    // public methods
    //--------------------------------------------------------------------
    virtual void SetPosition( D3DXVECTOR3 position ) = 0;
    virtual void SetDirection( D3DXVECTOR3 direction ) = 0;
    virtual void SetUpVector( D3DXVECTOR3 up ) = 0;
    virtual void Compute() = 0;
    virtual D3DXVECTOR3 GetPosition() = 0;
    virtual D3DXVECTOR3 GetDirection() = 0;
    virtual D3DXVECTOR3 GetUpVector() = 0;
    virtual D3DXMATRIX  GetView() = 0;
};

} // namespace SampleProgram
} // namespace Asura

#endif//__ASURA_DIRECTX_DEMO_CAMERA_H__